/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

Significant parts of the SMTSIM simulator were written by Jack Lo.
Therefore the following copyrights may also apply:

Copyright (C) Jack Lo
 */


#ifndef _STASH_H_DEFINED
#define _STASH_H_DEFINED

/* this contains all of the static information about an
   instruction that we only want to gather once.
 */

typedef struct StashDataStruct
{
	unsigned long *RA;
	unsigned long *RB;
	unsigned long *RC;
	int whichfu;
	int branch;
	int taken;
	int condbranch;
	unsigned long br_target;
	unsigned int offset;
	int srchaz1;
	int srchaz2;
	int desthaz;
	unsigned int delay;
	unsigned int inst;
	void (*emulate)();
	long rbv;
	int smt_primitive;
	int syncop;
} StashData;

void init_stash();
int get_stash_data();
void print_stash_stats();

#endif _STACK_H_DEFINED

